<?php
/*
Wettkampfabwicklung, Aktion: dms_mannschaften
verwendete Templates:
 - 42.dms-streckenschwimmerzuordnen.inc.html
*/
$mannschaften = array();
foreach($_wkeinst['dms'] as $key => $schwimmer){
	$mannschaften[$key] = array(
		'mw' => $key[0],
		'nr' => $key[1],
		'titel' => $key[1].'. Mannschaft '.$_geschlechter[$key[0]],
		'schwimmer' => empty($schwimmer)?false:explode('|', $schwimmer)
	);
}
require_once(PFAD_INCLUDE.'class/dms.inc.php');
$_dms = new dms($_db, $_SESSION['wk_abwickeln']['id']);


$select = array();
foreach($mannschaften as $key => $row){
	$select[$key] = $row['titel'];
}
$_tmpl->assign('mannschaften', $select);
$_m = false;
$_sort = 'wknr';

if(isset($_GET['mannschaft']) and array_key_exists($_GET['mannschaft'], $mannschaften)){
	$_m = $_GET['mannschaft'];
	$sort = $_GET['sort']=='strecke'?'strecke':false;
	$_strecken = [
		'1' => $_dms->holeWettkampfliste(['mw'=>$_m[0],'abschnitt'=>1], $sort),
		'2' => $_dms->holeWettkampfliste(['mw'=>$_m[0],'abschnitt'=>2], $sort)
	];
	$_tmpl->assign('_strecken', $_strecken);
	$_tmpl->assign('_lagen', $_lagen);
	$schwimmer = $zehnjaehrige = [];
	if(is_array($mannschaften[$_m]['schwimmer'])){
		$query = "SELECT id, CONCAT(nachname, ', ', vorname, ' (', YEAR(gebdatum), ')') as name
					FROM ".DB_PREFIX."mitglieder
					WHERE id IN (".implode(',', $mannschaften[$_m]['schwimmer']).")
					ORDER BY nachname, vorname";
		$_db->holeDaten($query);
		$schwimmer = $_db->baueArray('name', 'id');
		# die zehnjährigen holen (die dürfen nicht alles schwimmen)
		$query = "SELECT id	FROM ".DB_PREFIX."mitglieder
					WHERE id IN (".implode(',', $mannschaften[$_m]['schwimmer']).") AND 
						YEAR('".$_SESSION['wk_abwickeln']['wettkampfdatum']."')-YEAR(gebdatum) = 10";
		$_db->holeDaten($query);
		$zehnjaehrige = $_db->baueArray('id', '#');
	}
	$_tmpl->assign('schwimmer', $schwimmer);
	$_tmpl->assign('zehnjaehrige', $zehnjaehrige);

	# schon gespeicherte Strecken holen
	#$strecken = array();
	$strecken = $_dms->leseStreckenzuordnung($_m);
	#print_r($strecken);exit;
	#if(isset($_wkeinst['dmsstreckenzuordnung']) and isset($_wkeinst['dmsstreckenzuordnung'][$_m])){
	#	$strecken = json_decode(str_replace("'",'"',$_wkeinst['dmsstreckenzuordnung'][$_m]), true);
	#}

	if(isset($_POST['speichern'])){
		$mitgliederstarts = array(
			'anzahl' => array(),
			'strecken' => array()
		);
		$f = '';
		#print_r($_POST);
		#exit;
		foreach($_POST['strecken'] as $abschn => $adat){
			foreach($adat as $disziplin => $ddat){
				foreach($ddat as $laenge => $mid){
					if($mid == '-'){
						continue;
					}
					if(!array_key_exists($mid, $schwimmer)){
						$_POST['strecken'][$abschn][$disziplin][$laenge] = '';
						continue;
					}
					if((($disziplin==1 and in_array($laenge,array(800,1500))) or ($disziplin==4 and $laenge==200) or ($disziplin==5 and $laenge==400)) and in_array($mid, $zehnjaehrige)){
						$f .= 'Zehnjährige dürfen über die Strecken 800/1500F, 200S und 400L nicht starten<br />';
					}
					if(!isset($mitgliederstarts['anzahl'][$mid])){
						$mitgliederstarts['anzahl'][$mid] = 1;
					}
					else{
						$mitgliederstarts['anzahl'][$mid]++;
					}
					if(!isset($mitgliederstarts['strecken'][$disziplin.'_'.$laenge])){
						$mitgliederstarts['strecken'][$disziplin.'_'.$laenge] = $mid;
					}
					else{
						if($mitgliederstarts['strecken'][$disziplin.'_'.$laenge] == $mid){
							$f .= 'Eine Strecke darf von jedem Mitglied nur einmal geschwommen werden ('.$laenge.'m '.$_lagen[$disziplin].')<br />';
						}
					}
				}
			}
		}
		foreach($mitgliederstarts['anzahl'] as $mid => $anz){
			if($anz <= 5){
				continue;
			}
			$f .= 'Jeder Schwimmer darf nur max. 5mal starten ('.text_format($schwimmer[$mid],'html').')<br />';
		}

		if(empty($f)){
			$_dms->schreibeStreckenzuordnung($_m, $_POST['strecken']);
			$_SESSION['hinweis'] = 'Die Änderungen wurden gespeichert';
		}
		else{
			$_tmpl->assign('fehler', $f);

		}
		$strecken = $_POST['strecken'];
	}
	$_tmpl->assign('strecken', $strecken);
}

$_sortierennach = array(
	'wknr' => 'Wettkampfnummer',
	'strecke' => 'Strecke/Streckenlänge'
);
$_tmpl->assign('sortierennach', $_sortierennach);
#$_tmpl->assign('sort', $_sort);
$_tmpl->assign('m', $_m);
$_inh .= $_tmpl->fetch('wettkaempfe/42.dms-streckenschwimmerzuordnen.inc.html');
# EOF
